From 26f7113dd27680412e23b3d2f6345c66a6b8d275 Mon Sep 17 00:00:00 2001
From: Bhaskar <niceguy108@gmail.com>
Date: Thu, 23 May 2013 16:29:40 +0530
Subject: [PATCH] * Bugfix in Firmware loader main.c: Assigning correct value
 to data pointer to write/flash memory.

Wrong value was introduced in last update when msgb_get() was replaced by msgb_pull()
which returns end of data instead of start of data.
---
 src/target/firmware/apps/loader/main.c     |    4 ++--
 src/target/firmware/apps/loader_mtk/main.c |    4 ++--
 2 files changed, 4 insertions(+), 4 deletions(-)

diff --git a/src/target/firmware/apps/loader/main.c b/src/target/firmware/apps/loader/main.c
index c74c045..8d3633e 100644
--- a/src/target/firmware/apps/loader/main.c
+++ b/src/target/firmware/apps/loader/main.c
@@ -281,7 +281,7 @@ static void cmd_handler(uint8_t dlci, struct msgb *msg)
 		crc = msgb_pull_u16(msg);
 		address = msgb_pull_u32(msg);
 
-		data = msgb_pull(msg, nbytes);
+		data = msgb_pull(msg, nbytes) - nbytes;
 
 		mycrc = osmo_crc16(0, data, nbytes);
 
@@ -399,7 +399,7 @@ static void cmd_handler(uint8_t dlci, struct msgb *msg)
 		chip = msgb_pull_u8(msg);
 		address = msgb_pull_u32(msg);
 
-		data = msgb_pull(msg, nbytes);
+		data = msgb_pull(msg, nbytes) - nbytes;
 
 		mycrc = osmo_crc16(0, data, nbytes);
 
diff --git a/src/target/firmware/apps/loader_mtk/main.c b/src/target/firmware/apps/loader_mtk/main.c
index 43fbb56..f2ebbea 100644
--- a/src/target/firmware/apps/loader_mtk/main.c
+++ b/src/target/firmware/apps/loader_mtk/main.c
@@ -215,7 +215,7 @@ static void cmd_handler(uint8_t dlci, struct msgb *msg)
 		crc = msgb_pull_u16(msg);
 		address = msgb_pull_u32(msg);
 
-		data = msgb_pull(msg, nbytes);
+		data = msgb_pull(msg, nbytes) - nbytes;
 
 		mycrc = osmo_crc16(0, data, nbytes);
 
@@ -333,7 +333,7 @@ static void cmd_handler(uint8_t dlci, struct msgb *msg)
 		chip = msgb_pull_u8(msg);
 		address = msgb_pull_u32(msg);
 
-		data = msgb_pull(msg, nbytes);
+		data = msgb_pull(msg, nbytes) - nbytes;
 
 		mycrc = osmo_crc16(0, data, nbytes);
 
-- 
1.7.9

